std::is_compound(3)

NAME
std::is_compound - std::is_compound

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_compound;
   If T is a compound type (that is, array, function, object pointer, function pointer,
   member object pointer, member function pointer, reference, class, union, or
   enumeration, including any cv-qualified variants), provides the member constant
   value equal true. For any other type, value is false.
   The behavior of a program that adds specializations for is_compound
   or is_compound_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_compound_v = is_compound<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a compound type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   Compound types are the types that are constructed from fundamental types. Any C++
   type is either fundamental or compound.

Possible implementation
   template< class T >
   struct is_compound : std::integral_constant<bool, !std::is_fundamental<T>::value> {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 int main() {
     class cls {};
     std::cout << (std::is_compound<cls>::value
                      ? "`cls` is compound"
                      : "`cls` is not a compound") << '\n';
     std::cout << (std::is_compound_v<int>
                      ? "`int` is compound"
                      : "`int` is not a compound") << '\n';
 }

Output:
 `cls` is compound
 `int` is not a compound

See also
   is_fundamental checks if a type is a fundamental type
   (C++11) (class template)
   is_scalar checks if a type is a scalar type
   (C++11) (class template)
   is_object checks if a type is an object type
   (C++11) (class template)
   is_array checks if a type is an array type
   (C++11) (class template)